function Est31700_Etiqueta_de_Produto_Controller(ScreenService, restEngine, General, templateManager, ZhFilterPreferences, EstUtil) {


    this.validacoesWidgetOnEnterOnce = function(filtroArgs) {
        var cabecalhoWidget = filtroArgs.owner;
        const defaultFilter = {
            "DTENTRSAID": "01/01/2018",
            "IDENTRSAIDOP": "E",
            "FILTRADOPOR": "",
            "CDFILIAL": "",
            "NRORG": ""
        };
        General.callRestEngine("est#/crud/filial", "FilterData", [{ name: "CDFILIAL", operator: "=", value: "FILIAL_LOGADA" }]).then((response) => {
                defaultFilter.CDFILIAL = response.dataset.filial[0].CDFILIAL;
                defaultFilter.NMFILIAL = response.dataset.filial[0].NMFILIAL;
                ZhFilterPreferences.setOriginalFilter(cabecalhoWidget.id, defaultFilter);
                ZhFilterPreferences.openFilterWidget(cabecalhoWidget, defaultFilter);
            },
            (error) => {
                ZhFilterPreferences.openFilterWidget(cabecalhoWidget);
            });
    };

    this.removeCaposFiltrer = function(widget, preference) {

        let filterRow = preference.FILTER_ROW;
        let filter = widget.dataSourceFilter;
        let newDataFilter = [];

        filter = [
            {
                name: "CDFILIAL",
                operator: "=",
                value: filterRow.CDFILIAL
            }
        ];

        switch (filterRow.FILTRADOPOR) {
            case "NF":
            case "LNF":
                newDataFilter = [
                    {
                        name: "NRLANCTONF",
                        operator: "=",
                        value: filterRow.NUMERO
                        },
                    {
                        name: "IDENTRSAIDOP",
                        operator: "=",
                        value: filterRow.IDENTRSAIDOP
                        },
                    {
                        name: "IDORIGDESTNF",
                        operator: "=",
                        value: filterRow.IDORIGDESTNF
                        }
                    ];

                filter = filter.concat(newDataFilter);

                break;
            case "LEst":
                newDataFilter = {
                    name: "NRLANCESTQ",
                    operator: "=",
                    value: filterRow.NUMERO
                };

                filter.push(newDataFilter);

                break;
            case "OP":
                newDataFilter = [
                    {
                        name: "NRORDPROD",
                        operator: "=",
                        value: filterRow.NUMERO
                    },
                    {
                        name: "NRSUBORDPROD",
                        operator: "=",
                        value: filterRow.NRSUBORDPROD
                    }
                ];

                filter = filter.concat(newDataFilter);

                break;
        }

        widget.dataSourceFilter = filter;
        widget.reload();
    };

    this.getFieldValueFilter = function(filedName, widgetName) {
        var container = templateManager.container;
        if (container) {
            var filterWidget;
            var filterBforeApply = templateManager.container.getActiveWidget();
            if (filterBforeApply.name == 'zhFilterPreferencesSelectConditions')
                filterWidget = filterBforeApply;
            else {
                var f = container.getWidget(widgetName);
                if (f) {
                    filterWidget = container.getWidget(widgetName).appliedFilter;
                }

            }

            if (filterWidget) {
                var valueField;
                if (filterBforeApply.name == 'zhFilterPreferencesSelectConditions')
                    valueField = filterWidget.currentRow[filedName];
                else
                    valueField = filterWidget.FILTER_ROW[filedName];

                return valueField || null;
            }
            else return null;
        }
        else return null;
    };

    /****************************************************************
     * Ao escolher as opções “Nº Nota Fiscal” ou “Nº Lançamento de NF” deverá ser 
     * apresentado na pesquisa de número os seguintes campos:
     * Número NF, Série, Data Entrada, Razão Social
     * Quando a pesquisa for por “Nº Lançamento de Estoque” deverá ser exibibido os campos:
     * Número, Data Lançamento
     * ***************************************************************/
    this.HabilitaCamposNumero = function(widget) {
        let fieldsBool = [];
        let fieldNumero = widget.getField("NUMERO");

        switch (widget.currentRow.FILTRADOPOR) {

            case "NF":

                fieldNumero.dataSource.name = "est_relatorios#/crud/numero_nota_fiscal";
                fieldNumero.searchableFields = ["NRNOTAFISC", "SERIE", "NMRAZSOCFORN"];
                fieldNumero.displayedFields = ["NRNOTAFISC", "SERIE", "NMRAZSOCFORN"];
                fieldNumero.dataSourceFilter[2].name = "DTENTRSAID";

                fieldsBool = [
                    { "name": "NRNOTAFISC", "value": false },
                    { "name": "NRLANCTONF", "value": true },
                    { "name": "NRLANCESTQ", "value": false },
                    { "name": "NRORDPROD", "value": false },
                    { "name": "NRSUBORDPROD", "value": false },
                    { "name": "SERIE", "value": true },
                    { "name": "DATA", "value": true },
                    { "name": "NMRAZSOCFORN", "value": true },
                    { "name": "IDENTRSAIDOP", "value": false }
                ];

                this.checkFieldsVisibility(fieldsBool, fieldNumero);
                break;
            case "LNF":

                fieldNumero.dataSource.name = "est_relatorios#/crud/numero_lancamento_nf";
                fieldNumero.searchableFields = ["NRLANCTONF", "SERIE", "DATA"];
                fieldNumero.displayedFields = ["NRLANCTONF", "SERIE", "DATA"];
                fieldNumero.dataSourceFilter[2].name = "DTENTRSAID";

                fieldsBool = [
                    { "name": "NRNOTAFISC", "value": false },
                    { "name": "NRLANCTONF", "value": true },
                    { "name": "NRLANCESTQ", "value": false },
                    { "name": "NRORDPROD", "value": false },
                    { "name": "NRSUBORDPROD", "value": false },
                    { "name": "SERIE", "value": true },
                    { "name": "DATA", "value": true },
                    { "name": "NMRAZSOCFORN", "value": false },
                    { "name": "IDENTRSAIDOP", "value": false }
                ];

                this.checkFieldsVisibility(fieldsBool, fieldNumero);
                break;
            case "LEst":

                fieldNumero.dataSource.name = "est_relatorios#/crud/numero_lancamento_estoque";
                fieldNumero.searchableFields = ["NRLANCESTQ", "DATA"];
                fieldNumero.displayedFields = ["NRLANCESTQ", "DATA"];
                fieldNumero.dataSourceFilter[2].name = "DTLANCESTQ";

                fieldsBool = [
                    { "name": "NRNOTAFISC", "value": false },
                    { "name": "NRLANCTONF", "value": false },
                    { "name": "NRLANCESTQ", "value": true },
                    { "name": "NRORDPROD", "value": false },
                    { "name": "NRSUBORDPROD", "value": false },
                    { "name": "SERIE", "value": false },
                    { "name": "DATA", "value": true },
                    { "name": "NMRAZSOCFORN", "value": false },
                    { "name": "IDENTRSAIDOP", "value": false }
                ];

                this.checkFieldsVisibility(fieldsBool, fieldNumero);
                break;
            case "OP":

                fieldNumero.dataSource.name = "est_relatorios#/crud/numero_ordem_producao";
                fieldNumero.searchableFields = ["NRORDPROD", "DATA"];
                fieldNumero.displayedFields = ["NRORDPROD", "DATA"];
                fieldNumero.dataSourceFilter[2].name = "DTHRINICIAOP";

                fieldsBool = [
                    { "name": "NRNOTAFISC", "value": false },
                    { "name": "NRLANCTONF", "value": false },
                    { "name": "NRLANCESTQ", "value": false },
                    { "name": "NRORDPROD", "value": true },
                    { "name": "NRSUBORDPROD", "value": false },
                    { "name": "SERIE", "value": false },
                    { "name": "DATA", "value": true },
                    { "name": "NMRAZSOCFORN", "value": false },
                    { "name": "IDENTRSAIDOP", "value": false }
                ];

                this.checkFieldsVisibility(fieldsBool, fieldNumero);

                break;
            default:
                fieldNumero.readOnly = true;
        }
    };

    this.checkFieldsVisibility = function(fieldsObj, numero) {

        if (numero.selectWidget) {
            fieldsObj.forEach((field) => {
                numero.selectWidget.getField(field.name).showOnList = field.value;
            });
        }
        else {
            fieldsObj.forEach((field) => {
                numero.getField(field.name).showOnList = field.value;
            });
        }
    };

    this.HabilitaNumero = function(widget) {
        if ((widget.currentRow.FILTRADOPOR == null || widget.currentRow.FILTRADOPOR == undefined || widget.currentRow.FILTRADOPOR == "") || (widget.currentRow.IDENTRSAIDOP == null || widget.currentRow.IDENTRSAIDOP == undefined || widget.currentRow.IDENTRSAIDOP == "") || (widget.currentRow.DTENTRSAID == null || widget.currentRow.DTENTRSAID == undefined || widget.currentRow.DTENTRSAID == "") || (widget.currentRow.NMFILIAL == null || widget.currentRow.NMFILIAL == undefined || widget.currentRow.NMFILIAL == "")) {
            widget.getField("NUMERO").readOnly = true;
        }
        else {
            widget.getField("NUMERO").readOnly = false;
        }
        widget.currentRow.NUMERO = '';
        widget.getField("NUMERO").reload();
    };
    
    this.gerarEtiqueta = function (widget) {
       let rows = widget.getCheckedRows();
       let ignoresProperties = ["__is_new" , "__isSelected"];
       let produtos = [];
       
       rows.forEach( function(row){
           produtos.push(Util.clone(row, ignoresProperties));
       } );
    
       if(widget.hasCheckedRows()){
           this.requestReport(produtos).then(function(birtURL){
               window.open(birtURL.dataset.URL[0]);
           });
       }
    };

    this.requestReport = function(rows) {
        return restEngine.post('est_relatorios#/etiqueta_De_Produto', {
            "requestType": "DataSet",
            "dataset": rows
        });
    };

    this.onChangeFilial = function(widget) {
        var numero = widget.getField("NUMERO");

        numero.dataSourceFilter[1] = {
            "name": "CDFILIAL",
            "operator": "=",
            "value": widget.currentRow.CDFILIAL
        };
    };

    this.onChangeData = function(widget) {
        var numero = widget.getField("NUMERO");
        var data = widget.getField("DTENTRSAID");

        numero.dataSourceFilter[2] = {
            "name": "DTENTRSAID",
            "operator": "=",
            "value": data.value()
        };
    };

    this.onChangeId = function(widget) {
        var numero = widget.getField("NUMERO");
        var id = widget.getField("IDENTRSAIDOP");

        numero.dataSourceFilter[0] = {
            "name": "IDENTRSAIDOP",
            "operator": "=",
            "value": id.value()
        };
    };

    this.initializeNumero = function(args) {
        let widget = args.owner.field.widget;
        let numero = widget.getField("NUMERO");
        let complementaryData = [];

        numero.dataSourceFilter = [
            {
                "name": "CDFILIAL",
                "operator": "=",
                "value": widget.currentRow.CDFILIAL
            },
            {
                "name": "IDENTRSAIDOP",
                "operator": "=",
                "value": widget.getField("IDENTRSAIDOP").value()
            },
            {
                "name": "DTENTRSAID",
                "operator": "=",
                "value": widget.getField("DTENTRSAID").value()
            }

        ];

        switch (widget.currentRow.FILTRADOPOR) {
            case "NF":

                complementaryData = {
                    "name": "NRNOTAFISC",
                    "operator": "=",
                    "value": ""
                };

                numero.dataSourceFilter.push(complementaryData);
                this.checkFieldOutData(numero, "NRLANCTONF");

                break;
            case "LNF":
                complementaryData = {
                    "name": "NRLANCTONF",
                    "operator": "=",
                    "value": ""
                };

                numero.dataSourceFilter.push(complementaryData);
                this.checkFieldOutData(numero, "NRLANCTONF");

                break;
            case "LEst":
                numero.dataSourceFilter.pop();
                complementaryData = [
                    {
                        "name": "NRLANCESTQ",
                        "operator": "=",
                        "value": ""
                    },
                    {
                        "name": "DTLANCESTQ",
                        "operator": "=",
                        "value": widget.getField("DTENTRSAID").value()
                    }
                ];
                numero.dataSourceFilter = numero.dataSourceFilter.concat(complementaryData);
                this.checkFieldOutData(numero, "NRLANCESTQ");

                break;
            case "OP":
                numero.dataSourceFilter = numero.dataSourceFilter.filter((data) => {
                    return data.name == 'CDFILIAL';
                });

                complementaryData = [
                    {
                        "name": "NRORDPROD",
                        "operator": "=",
                        "value": ""
                    },
                    {
                        "name": "NRSUBORDPROD",
                        "operator": "=",
                        "value": ""
                    },
                    {
                        "name": "DTHRINICIAOP",
                        "operator": "=",
                        "value": widget.getField("DTENTRSAID").value()
                    }
                ];

                numero.dataSourceFilter = numero.dataSourceFilter.concat(complementaryData);
                this.checkFieldOutData(numero, "NRORDPROD");

                break;
        }
        numero.reload();
    };

    this.checkFieldOutData = function(numero, fieldName) {
        delete numero.outData.NRNOTAFISC;
        delete numero.outData.NRLANCTONF;
        delete numero.outData.NRLANCESTQ;
        delete numero.outData.NRORDPROD;
        delete numero.outData.NRSUBORDPROD;
        delete numero.outData.IDORIGDESTNF;

        numero.outData[fieldName] = "NUMERO";

        if (fieldName == 'NRORDPROD') {
            fieldName = "NRSUBORDPROD";
            numero.outData[fieldName] = "NRSUBORDPROD";
        }
        if (fieldName == 'NRNOTAFISC' || fieldName == 'NRLANCTONF') {
            fieldName = "IDORIGDESTNF";
            numero.outData[fieldName] = "IDORIGDESTNF";
        }
    };
}
Configuration(function(ContextRegister) {
    ContextRegister.register('Est31700_Etiqueta_de_Produto_Controller', Est31700_Etiqueta_de_Produto_Controller);
});
