function LibZdNextListener(ScreenService, LibLoginService, LibUtilities) {
    window.addEventListener('message', handleMessageEvent);

    function handleMessageEvent(event) {
        if(event.data.type === 'logoutByZdNext') {
            logoutByZdNext()
        }
    }

    var logoutByZdNext = function() {
        ScreenService.showLoader();
        LibLoginService.logout().then(function () {
            ScreenService.hideLoader();
            localStorage.removeItem('IS_LOGGED');
            localStorage.removeItem('LOGIN_USER');
            localStorage.removeItem('LOGIN_TOKEN');
            localStorage.removeItem('LOGIN_ERASE_HASH');
            localStorage.removeItem('LOGIN_REDIRECT_URL');
            LibUtilities.redirectToLogin();
        }).catch(function(error) {
            ScreenService.hideLoader();
            LibUtilities.showErrorMessage(error);
        });
    };
}

Configuration(function(ContextRegister){
    ContextRegister.register('LibZdNextListener', LibZdNextListener);
});
